﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace szamok
{
    class Feladat
    {
        public int Pont { get; set; }
        public int Válasz { get; set; }
        public string Téma { get; set; }
        public string Kérdés { get; set; }

        public double Random { get; set; }

        public Feladat(string kérdés, string[] értékelés)
        {
            Pont = int.Parse(értékelés[1]);
            Válasz = int.Parse(értékelés[0]);
            Téma = értékelés[2];
            Kérdés = kérdés;
            Random = -1;
        }
    }

    class Program
    {
        static List<Feladat> feladatok = new List<Feladat>();
        static Random rnd = new Random();

        static void Main(string[] args)
        {
            Console.WriteLine("\n1. feladat");
            Feladat01();    //adatbeolvasás
            Console.WriteLine("\n2. feladat");
            Feladat02();    //beolvasott feladatok száma
            Console.WriteLine("\n3. feladat");
            Feladat03();    //matematika feladatok száma, pontszámonként is
            Console.WriteLine("\n4. feladat");
            Feladat04();    //min-max pont
            Console.WriteLine("\n5. feladat");
            Feladat05();    //témakörök kigyűjtése
            Console.WriteLine("\n6. feladat");
            Feladat06();    //egy választott témakör sorsolt feladata
            Console.WriteLine("\n7. feladat");
            Feladat07();    //egy választott témakör sorsolt feladata

            Console.ReadLine();
        }

        private static void Feladat07()
        {
            foreach (Feladat f in feladatok)
            {
                f.Random = rnd.NextDouble();
            }
            for (int i = 0; i < feladatok.Count - 1; i++)
            {
                int min = i;
                for (int j = i+1; j < feladatok.Count; j++)
                {
                    if (feladatok[j].Random < feladatok[min].Random)
                    {
                        min = j;
                    }
                }
                Feladat csere = feladatok[i];
                feladatok[i] = feladatok[min];
                feladatok[min] = csere;
            }
            using (System.IO.StreamWriter writer = new System.IO.StreamWriter("tesztel.txt"))
            {
                int szum = 0;
                for (int i = 0; i < Math.Min(feladatok.Count, 10); i++)
                {
                    writer.WriteLine("{0} {1} {2}",feladatok[i].Pont, feladatok[i].Válasz, feladatok[i].Kérdés );
                    szum += feladatok[i].Pont;
                }
                writer.WriteLine("\r\nA feladatsorra osszesen {0} pont adhato.",szum);
            }
            Console.WriteLine("A fájlbaírás kész");
        }

        private static void Feladat06()
        {
            Console.Write("\tMilyen temakorbol szeretne kerdest kapni? ");
            string téma = Console.ReadLine();
            
            Feladat választott = new Feladat("", new string[]{"0", "0", "0"});
            double sors = -1;
            foreach (Feladat f in feladatok)
            {
                if (f.Téma == téma)
                {
                    double uj = rnd.NextDouble();
                    if ( uj > sors )
                    {
                        választott = f;
                        sors = uj;
                    }

                }
            }

            Console.Write("\t" + választott.Kérdés + " ");
            int válasz = int.Parse(Console.ReadLine());
            if (válasz == választott.Válasz)
            {
                Console.WriteLine("\tA választ {0} pontot ér.", választott.Pont);
            }
            else
            {
                Console.WriteLine("\tA választ 0 pontot ér.\n\tA helyes válasz: {0}", választott.Válasz);
            }
        }

        private static void Feladat05()
        {
            List<string> témakörök = new List<string>();
            foreach (Feladat f in feladatok)
            {
                int t = 0;
                while (t< témakörök.Count && f.Téma != témakörök[t])
                {
                    t++;
                }
                if (t == témakörök.Count)
                {
                    témakörök.Add(f.Téma);
                }
            }
            foreach (string téma in témakörök)
            {
                Console.WriteLine("\t" + téma);
            }
        }

        private static void Feladat04()
        {
            int min = feladatok[0].Válasz;
            int max = feladatok[0].Válasz;
            for (int i = 0; i < feladatok.Count; i++)
            {
                if (feladatok[i].Válasz > max)
                {
                    max = feladatok[i].Válasz;
                }
                if (feladatok[i].Válasz < min)
                {
                    min = feladatok[i].Válasz;
                }
            }
            Console.WriteLine("A válaszok a [{0}, {1}] intervallumban találhatók", min, max);
        }

        private static void Feladat03()
        {
            int[] pont = new int[4];
            foreach (Feladat f in feladatok)
            {
                if (f.Téma == "matematika")
                {
                    pont[f.Pont]++;
                }
            }
            int szum = pont[1] + pont[2] + pont[3];

            Console.WriteLine("Az adatfájlban {0} matematika feladat van, 1 pontot ér {1} feladat, 2 pontot ér {2} feladat, 3 pontot ér {3} feladat.", szum, pont[1], pont[2], pont[3]);
        }

        private static void Feladat02()
        {
            Console.WriteLine("A feladatsorban {0} feladat van",feladatok.Count);
        }

        private static void Feladat01()
        {
            using (System.IO.StreamReader reader = new System.IO.StreamReader("felszam.txt"))
            {
                while (!reader.EndOfStream)
                {
                    feladatok.Add(new Feladat(reader.ReadLine(), reader.ReadLine().Split(' ')));
                }
            }
            Console.WriteLine("Fájlbeolvasás kész");
        }
    }
}
